<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css">
<style>

/* General body styling */
body {
    font-family: Arial, sans-serif; /* Set font family */
    background-color: #f8f9fa; /* Light background color for the body */
    margin: 0; /* Remove default margin */
    padding: 0px; /* Add some padding */
}

/* Form styling */
.message-form {
    background-color: white; /* White background for the form */
    border-radius: 8px; /* Rounded corners */
    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1); /* Subtle shadow */
    padding: 20px; /* Add padding inside the form */
    max-width: 500px; /* Limit the width of the form */
    margin: auto; /* Center the form horizontally */
}

/* Input styling */
input[type="text"], textarea {
    width: 100%; /* Full width */
    padding: 10px; /* Padding inside inputs */
    margin-top: 5px; /* Spacing above the inputs */
    border: 1px solid #ced4da; /* Light border */
    border-radius: 4px; /* Rounded corners */
    box-sizing: border-box; /* Include padding and border in width */
}

/* Textarea specific styling */
textarea {
    height: 100px;
    resize: none; /* Disable resizing for textarea */
}

/* Button styling */
button {
    background-color: #007bff; /* Primary button color */
    color: white; /* Text color */
    border: none; /* Remove default border */
    padding: 10px 20px; /* Padding for button */
    border-radius: 4px; /* Rounded corners */
    cursor: pointer; /* Pointer on hover */
    margin-top: 15px; /* Space above the button */
    transition: background-color 0.3s; /* Smooth transition */
}

button:hover {
    background-color: #0056b3; /* Darken button on hover */
}

/* Message count styling */
.message-count {
    text-align: center; /* Center the text */
    margin-top: 20px; /* Space above the message count */
    font-size: 16px; /* Font size for the message count */
    color: #333; /* Text color */
}

.card-container {
    display: flex;
    flex-wrap: wrap; /* Allows cards to wrap on smaller screens */
    gap: 10px; /* Adds space between cards */
    justify-content: flex-start; /* Ensures spacing between items */
    align-items: flex-start; /* 只調整展開的卡片 */
    padding: 5px;
    width: 100%; /* Ensures the container takes full width */
    margin-left: 0; /* Remove left margin if exists */
    margin-right: 0; /* Remove right margin if exists */
    box-sizing: border-box; /* Ensures padding is included in the element’s total width and height */
    background-color: #f8f9fa; /* Slightly off-white background */
}

.card {
    flex-grow: 1; /* 允許卡片根據可用空間增長 */
    margin: 5px; /* Add vertical margin between rows */
    background-color: #ffffff;
    border-radius: 15px; /* Rounded corners for app-like design */
    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1); /* Soft shadow for depth */
    padding: 5px;
    transition: transform 0.2s ease, box-shadow 0.2s ease; /* Smooth animation for interaction */
    position: relative; /* 必須相對定位，讓 .badge-box 能相對於它定位 */
    min-width: 50px;
}

.card:hover {
    transform: translateY(-5px); /* Slight lift on hover */
    box-shadow: 0 8px 16px rgba(0, 0, 0, 0.2); /* Deepen the shadow on hover */
}

.card-body {
    text-align: center; /* Center text for a clean look */
}

.card-title {
    font-size: 1rem;
    font-weight: bold;
    color: #333; /* Darker text for contrast */
    word-wrap: break-word; /* 確保長詞換行 */
    white-space: normal; /* 允許換行 */
    line-height: 1; /* 調整行高，讓換行後的行距適當 */
    overflow-wrap: break-word; /* 確保長單詞會被換行 */
}

.card-text {
    color: #666; /* Subtle, grey color for supporting text */   
    white-space: pre-wrap;  /* Preserves whitespace and line breaks */
    word-wrap: break-word;  /* Breaks long words if needed */
    overflow-wrap: break-word; /* Ensures long text breaks to avoid overflow */
    line-height: 1.5; /* Explicitly set the line height */
}

.card.flex {
    flex: 0 1 calc(20% - 10px); /* 3 cards per row, with a gap 20% - 20px*/
}

.card.full-width {
    width: 100%; /* Full-width for longer content */
}

.card-body div {
    margin-bottom: 5px; /* Space below "姓名" */
}

.card-body .card-title {
    margin-top: 0; /* No space above card-title */
    margin-bottom: 0; /* Optional: Remove bottom margin */
}

.badge-box {
    position: absolute; /* 絕對定位 */
    top: 5px;
    right: 0px;
    background-color: #f0f0f0;
    color: #333;
    /*padding: 5px 5px; */
    border: 1px solid #ccc;
    border-radius: 5px;
    font-size: 8px;
}

.message-count {
    display: inline-block;
    background-color: #EE82EE; /* Light background for a clean look */
    color: #333; /* Dark text for readability */
    font-size: 16px; /* Font size similar to mobile text */
    font-weight: bold; /* Highlight the number */
    padding: 10px 20px; /* Add some padding to give it a button-like feel */
    border-radius: 25px; /* Rounded corners for an app-like appearance */
    box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1); /* Soft shadow for depth */
    text-align: center; /* Center-align the text */
    margin-top: 10px; /* Space from the top */
    width: fit-content; /* Automatically adjusts width to the content */
    margin-left: auto;
    margin-right: auto; /* Center align horizontally */
}

/* 美化按鈕的樣式 */
.button-container {
    display: flex; /* Use flexbox to align items */
    justify-content: center; /* Center items horizontally */
    margin-top: 10px; /* Add some spacing above the buttons */
}

.action-button {
    font-size: 16px; /* 調整字體大小 */
    margin: 0 5px; /* 保持水平間距 */
    padding: 8px 12px; /* 調整內部填充，減少高度 */
    background: linear-gradient(135deg, #007bff 0%, #0056b3 100%);
    color: white;
    border: none;
    border-radius: 5px; /* 圓角保持 */
    cursor: pointer;
    box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
    transition: background-color 0.3s ease, transform 0.2s ease;
    line-height: 1; /* 控制行高，避免內部文字拉伸 */
}

.action-button:hover {
    background: linear-gradient(135deg, #0056b3 0%, #004080 100%); /* Darken on hover */
    transform: translateY(-2px); /* Lift button on hover */
}

/* 刪除按鈕的樣式 */
.action-button.delete {
    background: linear-gradient(135deg, #f44336 0%, #d32f2f 100%); /* Gradient for delete button */
}

.action-button.delete:hover {
    background: linear-gradient(135deg, #d32f2f 0%, #b71c1c 100%); /* Darken on hover */
}

/* 自定義 Checkbox 樣式 */
input[type="checkbox"] {
    position: relative;
    width: 20px;
    height: 20px;
    -webkit-appearance: none; /* Remove default checkbox appearance */
    appearance: none;
    border: 2px solid #007bff; /* Checkbox border color */
    border-radius: 5px; /* Rounded corners */
    outline: none;
    cursor: pointer;
    transition: background-color 0.2s, border-color 0.2s;
}

input[type="checkbox"]:checked {
    background-color: #007bff; /* Background color when checked */
    border-color: #0056b3;
}

input[type="checkbox"]:checked::after {
    content: "✔"; /* Checkmark symbol */
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    color: white;
    font-size: 14px;
}

input[type="checkbox"]:hover {
    border-color: #0056b3; /* Change border color on hover */
}
	
	.action-button:hover {
	    background-color: #45a049; /* 編輯按鈕懸停顏色 */
	    transform: scale(1.05); /* 懸停時放大 */
	}
	
	.action-button.delete:hover {
	    background-color: #e53935; /* 刪除按鈕懸停顏色 */
	}

    /* 分頁樣式 */
    .pagination {
            text-align: center; /* 文字居中 */
            margin-top: 20px; /* 上邊距 */
        }

        .pagination a {
            margin: 0 5px;
            padding: 8px 16px;
            font-size: 16px;
            color: #4CAF50;
            text-decoration: none;
            border: 1px solid #4CAF50;
            border-radius: 4px;
        }

        .pagination a:hover {
            background-color: #4CAF50;
            color: white;
        }



/* Customize the look for even smaller screens like smartphones */
@media (max-width: 600px) {
    body {
        
        font-size: 1rem;
    }

    .badge-box {
        right: 10px;
    }
    .card.flex {
        flex: 0 1 calc(5%); /* 3 cards per row, with a gap */
    }

    /* 防止點擊時自動放大 */
    input[type="text"],
    textarea {
        font-size: 16px; /* 確保字體大小至少為16px */
    }

    /* 調整其他表單元素的樣式 */
    .message-form {
        font-size: 16px; /* 全局設置表單字體大小 */
    }

    .form-control {
        font-size: 16px; /* 對textarea應用 */
    }
    /*.card-title {
    /*    font-size: 1.25rem;
    /*}
    /*.card-text {        
    /*    font-size: 2rem;
    /*}
    */
}

/* On smaller screens, stack the cards vertically and center them */
@media (max-width: 768px) {
    body {        
        font-size: 1rem;
    }
    /*.card {        
    /*    font-size: 2rem;
    /*    margin-left: auto;
    /*    margin-right: auto;
    /*}
    */
}
</style>

<?php
    // 定義每頁顯示的筆數
    //$itemsPerPage = 12;
    $dataFile = 'data.json';

    $selectedDistrict = !empty($editEntry['district']) ? htmlspecialchars($editEntry['district']) : (!empty($_GET['district']) ? $_GET['district'] : '');

    // 讀取 JSON 資料
    function readData() {
        //global $dataFile;
        //if (file_exists($dataFile)) {
        //    $jsonData = file_get_contents($dataFile);
        //    return json_decode($jsonData, true);
        //}
        //return [];
        
        $selectedDistrict = !empty($editEntry['district']) ? htmlspecialchars($editEntry['district']) : (!empty($_GET['district']) ? $_GET['district'] : '');
        // 初始化 cURL
        $ch = curl_init();

        // 設置 cURL 選項
        curl_setopt($ch, CURLOPT_URL, "https://citcnew.org.tw/citcnew.org.tw/fion/berry_test/addCard.php"); // 請求的 URL //設定 URL
        curl_setopt($ch, CURLOPT_POST, true); // 指定請求為 POST
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // 將結果返回，而不是直接輸出
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query(array(
            'action' => 'qry',
            'district' => $selectedDistrict
        ))); // 發送的表單資料

        // 執行 cURL 請求
        $response = curl_exec($ch);

        // 檢查是否有錯誤
        if (curl_errno($ch)) {
            echo 'cURL error: ' . curl_error($ch);
        } else {
            // 輸出返回的內容
            //echo $response;
        }

        // 關閉 cURL
        curl_close($ch);
        return $response;
    }

    // 取得所有資料
    $data = readData();

    $data = json_decode($data, true);  // true 代表轉成關聯陣列
    
    //echo '<pre>'; print_r($data); echo '</pre>';

    //echo "<pre>".print_r($data)."</pre>";

    // 檢查是否有要編輯的項目
    $editEntry = null;
    if (isset($_GET['edit_id'])) {
        $editId = $_GET['edit_id'];
        foreach ($data as $entry) {
            if ($entry['id'] == $editId) {                
                //echo '<pre>'; print_r($entry); echo '</pre>';
                $editEntry = $entry;
                break;
            }
        }
    }

    //$selectedDistrict = !empty($editEntry['district']) ? htmlspecialchars($editEntry['district']) : (!empty($_GET['district']) ? $_GET['district'] : '');
    //
    //// Check if both search and district filters are set
    //if (isset($selectedDistrict)) {
    //    // Now you can use $selectedDistrict to filter your data accordingly
    //    $data = array_filter($data, function($entry) use ($selectedDistrict) {
    //        return $entry['district'] === $selectedDistrict; // Example condition for filtering
    //    });
    //}

    // 分頁功能
    $totalItems = count($data);
    //$page = isset($_GET['page']) ? (int)$_GET['page'] : 1;
    //$startIndex = ($page - 1) * $itemsPerPage;
    //$paginatedData = array_slice($data, $startIndex, $itemsPerPage);
    //$totalPages = ceil($totalItems / $itemsPerPage);
?>

<button type="button" id="messageForm-hide" onclick="toggleForm()"><?= $editEntry ? '取消' : '新增' ?></button>
<button type="button" id="messageForm-hide" onclick="OpenPrayer()">代禱得救名單</button>

<form action="addCard.php" id="messageForm" method="POST" class="message-form" style="<?= $editEntry ?? 'display: none;' ?> ">
    <input type="hidden" id="name-id" name="id" value="<?= htmlspecialchars($editEntry['id'] ?? '') ?>">
    姓名: <input type="text" id="name" name="name" value="<?= htmlspecialchars($editEntry['name'] ?? '') ?>" required><br>
    <div class="form-group">
        <label for="message">留言:</label>
        <textarea class="form-control" id="message" name="message" rows="3"><?= htmlspecialchars($editEntry['memo'] ?? '') ?></textarea>
    </div>
    <div id="districts" class="btn-group-toggle" data-toggle="buttons">
        <input type="hidden" id="district" name="district" value="<?= $selectedDistrict ?>"></input>
    </div>
    <button type="submit" id="submit-id" name="action" value="<?= $editEntry ? 'edit' : 'add' ?>">
        提交
    </button>
</form>
<div>total : <?= $totalItems ?> </div>
<div class="card-container">		
    <?php $index = 1; foreach ($data as $entry): ?>
        <div class="card mt-3" id="card-<?= htmlspecialchars($entry['id']) ?>" onclick="toggleMessage('<?= htmlspecialchars($entry['id']) ?>')">
            <div class="card-body">
                <!-- <div class="badge-box"><?= htmlspecialchars($entry['district']) ?></div> --> <!-- 右上角的框框 -->
                <div><?= $index ?></div>
                <p class="card-title"><?= htmlspecialchars($entry['name']) ?></p>
                <div id="title-<?= htmlspecialchars($entry['id']) ?>" style="display: none;">備註</div>
                <p class="card-text" 
                   id="message-<?= htmlspecialchars($entry['id']) ?>" style="display: none;"><?= htmlspecialchars($entry['memo']) ?></p>
            </div>
            <div class="button-container" id="messagebtn-<?= htmlspecialchars($entry['id']) ?>" style="display: none;">
               <a href="?edit_id=<?= htmlspecialchars($entry['id']) ?>&district=<?= htmlspecialchars($entry['district']) ?>" class="action-button" style="text-decoration: none;">
                   <i class="fas fa-edit"></i>
               </a>
               <form action="addCard.php" method="POST" style="display:inline;" onsubmit="return confirmDelete('<?= htmlspecialchars($entry['name']) ?>');">
                   <input type="hidden" name="id" value="<?= htmlspecialchars($entry['id']) ?>">
                   <input type="hidden" name="district" value="<?= htmlspecialchars($entry['district']) ?>">
                   <button type="submit" name="action" value="delete" class="action-button delete">
                    <i class="fas fa-trash-alt"></i>
                   </button>
               </form>
               <form action="addCard.php" method="POST" style="display:inline;">
                   <input type="hidden" name="id" value="<?= htmlspecialchars($entry['id']) ?>">
                   <input type="hidden" name="district" value="<?= htmlspecialchars($entry['district']) ?>">
                   <input type="hidden" name="action" value="prayer">
                   
                   <!-- 新增的 checkbox -->
                   <label for="prayer-checkbox">已得答應</label>
                   <input type="checkbox" id="prayer-checkbox" name="check" value="得救" onchange="checkboxSubmission(this);">
                   
               </form>
            </div>
        </div>
    <?php $index++; endforeach; ?>
</div>

<!-- 分頁連結 -->
<?php if (!$search && $totalPages > 1): ?>
    <div id="pages" class="pagination">
        <p>頁數：</p>
        <?php for ($i = 1; $i <= $totalPages; $i++): ?>
            <a href="?page=<?= $i ?>"><?= $i ?></a>
        <?php endfor; ?>
    </div>
<?php endif; ?>

<script>
    function confirmDelete(name) {
        return confirm(name + ' 確定要刪除這條記錄嗎？');
    }

    function checkboxSubmission(checkbox) {
        if (checkbox.checked) {  // 當 checkbox 被勾選時
            var userConfirmed = confirm("得救了嗎 ?");
            if (userConfirmed) {
                // 使用者點擊 "確定"，提交表單
                checkbox.form.submit();
            } else {
                // 使用者點擊 "取消"，取消勾選
                checkbox.checked = false;
            }
        }
    }

    // Function to check the content length and adjust layout
    //function adjustCardLayout() {
    //    const cards = document.querySelectorAll('.card');
//
    //    cards.forEach(card => {
    //        const cardText = card.querySelector('.card-text');
    //        let lineHeight = parseFloat(window.getComputedStyle(cardText).lineHeight);
//
    //        // Fallback to estimate line-height if it's 'normal'
    //        if (isNaN(lineHeight)) {
    //            const fontSize = parseFloat(window.getComputedStyle(cardText).fontSize);
    //            lineHeight = fontSize * 1.2;  // Rough estimate of line-height when set to 'normal'
    //        }
//
    //        const contentHeight = cardText.scrollHeight;
    //        const totalLines = contentHeight / lineHeight;
//
    //        // Adjust layout based on line count
    //        if (totalLines > 10) {
    //            card.classList.remove('flex');
    //            card.classList.add('full-width');
    //        } else {
    //            card.classList.add('flex');
    //            card.classList.remove('full-width');
    //        }
    //    });
    //}

    //function filterDistrict(selectedDistrict) {
    //    fetch('filter.php?district=' + selectedDistrict)
    //        .then(response => response.json())  // 解析 JSON
    //        .then(data => {
    //            const cardContainer = document.querySelector('.card-container');
    //            cardContainer.innerHTML = '';  // 清空原有內容
//
    //            const itemsPerPage = <?= $itemsPerPage ?>;  // 每頁顯示的條目數
    //            let currentPage = 1;  // 預設顯示第一頁
    //            const totalItems = data.length;
    //            const totalPages = Math.ceil(totalItems / itemsPerPage);  // 總頁數
//
    //            // 動態生成頁數
    //            const pageContainer = document.querySelector('.pagination');
    //            pageContainer.innerHTML = '';  // 清空頁數容器
//
    //            for (let i = 1; i <= totalPages; i++) {
    //                const pageLink = document.createElement('a');
    //                pageLink.href = '#';  // 使用錨鏈，避免刷新頁面
    //                pageLink.textContent = i;
    //                pageLink.addEventListener('click', (event) => {
    //                    event.preventDefault();  // 阻止默認行為
    //                    currentPage = i;  // 更換當前頁數
    //                    displayPage(currentPage);  // 顯示對應頁面的數據
    //                });
    //                pageContainer.appendChild(pageLink);
    //            }
//
    //            // 分頁顯示數據
    //            function displayPage(page) {
    //                cardContainer.innerHTML = '';  // 清空當前卡片容器
    //                const startIndex = (page - 1) * itemsPerPage;
    //                const paginatedData = data.slice(startIndex, startIndex + itemsPerPage);
//
    //                paginatedData.forEach(entry => {
    //                    const cardHTML = `
    //                        <div class="card mt-3" id="card-${entry.id}" onclick="toggleMessage('${entry.id}')">
    //                            <div class="card-body">
    //                                <div class="badge-box">${entry.district}</div> <!-- 右上角的框框 -->
    //                                <div>姓名</div>
    //                                <h5 class="card-title">${entry.name}</h5>
    //                                <div>備註</div>
    //                                <!-- 隱藏的備註區域 -->
    //                                <p class="card-text" id="message-${entry.id}"  style="display: none;">
    //                                    ${entry.message}
    //                                </p>
    //                            </div>
    //                            <div class="button-container">
    //                                <a href="?edit_id=${entry.id}" class="action-button">編輯</a>
    //                                <form action="addCard.php" method="POST" style="display:inline;" onsubmit="return confirmDelete('${entry.name}');">
    //                                    <input type="hidden" name="id" value="${entry.id}">
    //                                    <button type="submit" name="action" value="delete" class="action-button delete">刪除</button>
    //                                </form>
    //                            </div>
    //                        </div>
    //                    `;
    //                    cardContainer.insertAdjacentHTML('beforeend', cardHTML);
    //                });
    //                            
    //                //adjustCardLayout();toggleMessage
    function toggleMessage(cardId) {
        // 根據傳入的 cardId 找到對應的備註區域
        var titleElement = document.getElementById("title-" + cardId);
        var messageElement = document.getElementById("message-" + cardId);
        const cardElement = document.getElementById(`card-${cardId}`);
        var messagebtnElement = document.getElementById("messagebtn-" + cardId);

        // 切換顯示或隱藏
        if (messageElement.style.display === 'none' || messageElement.style.display === '') {
            titleElement.style.display = 'block';
            messageElement.style.display = 'block'; // 展開備註
            cardElement.scrollIntoView({ behavior: 'smooth', block: 'start' });
            messagebtnElement.style.display = 'flex';
        } else {
            titleElement.style.display = 'none';
            messageElement.style.display = 'none';  // 收起備註
            messagebtnElement.style.display = 'none';
        }
    }

    function toggleForm() {
        var form = document.getElementById('messageForm');
        var formType = document.getElementById('messageForm-hide');

        if(formType.innerText == "取消"){
            document.getElementById("name-id").value = '';
            document.getElementById("name").value = '';
            document.getElementById("message").value = '';
            document.getElementById("submit-id").value = 'add';
            formType.innerText = "新增";
        }

        if (form.style.display === 'none') {
            form.style.display = 'block'; // 顯示表單
        } else { 
            form.style.display = 'none'; // 隱藏表單
        }
    }

    function OpenPrayer() {
        var district = '<?= $selectedDistrict ?>';
        //document.getElementById('dynamicFrame').src = "prayer.php?district=" + encodeURIComponent(district);
        window.location.href = "prayer.php?district=" + encodeURIComponent(district);
        
    }

    // Call the function on page load
    //window.addEventListener('load', adjustCardLayout);
</script>