<meta name="viewport" content="width=device-width, initial-scale=1">
<style>

/* General body styling */
body {
    font-family: Arial, sans-serif; /* Set font family */
    background-color: #f8f9fa; /* Light background color for the body */
    margin: 0; /* Remove default margin */
    padding: 0px; /* Add some padding */
}

/* 表格樣式 */
table {
    width: 100%;
    border-collapse: collapse;
    margin-top: 20px; /* 上邊距 */
}
table, th, td {
    border: 1px solid #ddd; /* 邊框顏色 */
}
th, td {
    padding: 2px; /* 增加內邊距 */
    text-align: left;
}
th {
    background-color: #f2f2f2; /* 標題背景顏色 */
}

.message-count {
    display: inline-block;
    background-color: #EE82EE; /* Light background for a clean look */
    color: #333; /* Dark text for readability */
    font-size: 16px; /* Font size similar to mobile text */
    font-weight: bold; /* Highlight the number */
    padding: 10px 20px; /* Add some padding to give it a button-like feel */
    border-radius: 25px; /* Rounded corners for an app-like appearance */
    box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1); /* Soft shadow for depth */
    text-align: center; /* Center-align the text */
    margin-top: 10px; /* Space from the top */
    width: fit-content; /* Automatically adjusts width to the content */
    margin-left: auto;
    margin-right: auto; /* Center align horizontally */
}

.button-container {
    display: flex; /* Use flexbox to align items */
    justify-content: center; /* Center items horizontally */
    margin-top: 10px; /* Add some spacing above the buttons */
}

@media (max-width: 600px) {
    body {
        
        font-size: 1rem;
    }

    .badge-box {
        right: 10px;
    }
    .card.flex {
        flex: 0 1 calc(5%); /* 3 cards per row, with a gap */
    }

    /* 防止點擊時自動放大 */
    input[type="text"],
    textarea {
        font-size: 16px; /* 確保字體大小至少為16px */
    }

    /* 調整其他表單元素的樣式 */
    .message-form {
        font-size: 16px; /* 全局設置表單字體大小 */
    }

    .form-control {
        font-size: 16px; /* 對textarea應用 */
    }
    /*.card-title {
    /*    font-size: 1.25rem;
    /*}
    /*.card-text {        
    /*    font-size: 2rem;
    /*}
    */
}

/* On smaller screens, stack the cards vertically and center them */
@media (max-width: 768px) {
    body {        
        font-size: 1rem;
    }
}
</style>

<?php
    // 定義每頁顯示的筆數
    //$itemsPerPage = 12;
    $dataFile = 'data.json';

    $selectedDistrict = !empty($editEntry['district']) ? htmlspecialchars($editEntry['district']) : (!empty($_GET['district']) ? $_GET['district'] : '');

    // 讀取 JSON 資料
    function readData() {
        
        $selectedDistrict = !empty($editEntry['district']) ? htmlspecialchars($editEntry['district']) : (!empty($_GET['district']) ? $_GET['district'] : '');
        // 初始化 cURL
        $ch = curl_init();

        // 設置 cURL 選項
        curl_setopt($ch, CURLOPT_URL, "https://citcnew.org.tw/citcnew.org.tw/fion/berry_test/addCard.php"); // 請求的 URL //設定 URL
        curl_setopt($ch, CURLOPT_POST, true); // 指定請求為 POST
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // 將結果返回，而不是直接輸出
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query(array(
            'action' => 'qry2',
            'district' => $selectedDistrict
        ))); // 發送的表單資料

        // 執行 cURL 請求
        $response = curl_exec($ch);

        // 檢查是否有錯誤
        if (curl_errno($ch)) {
            echo 'cURL error: ' . curl_error($ch);
        } else {
            // 輸出返回的內容
            //echo $response;
        }

        // 關閉 cURL
        curl_close($ch);
        return $response;
    }

    // 取得所有資料
    $data = readData();

    $data = json_decode($data, true);  // true 代表轉成關聯陣列
    
    //echo '<pre>'; print_r($data); echo '</pre>';

    //echo "<pre>".print_r($data)."</pre>";

    // 檢查是否有要編輯的項目
    $editEntry = null;
    if (isset($_GET['edit_id'])) {
        $editId = $_GET['edit_id'];
        foreach ($data as $entry) {
            if ($entry['id'] == $editId) {                
                //echo '<pre>'; print_r($entry); echo '</pre>';
                $editEntry = $entry;
                break;
            }
        }
    }

    // 分頁功能
    $totalItems = count($data);
    //$page = isset($_GET['page']) ? (int)$_GET['page'] : 1;
    //$startIndex = ($page - 1) * $itemsPerPage;
    //$paginatedData = array_slice($data, $startIndex, $itemsPerPage);
    //$totalPages = ceil($totalItems / $itemsPerPage);
?>

<button type="button" id="messageForm-hide" onclick="toggleForm()">返回</button>

<div>total : <?= $totalItems ?> </div>		
<table>
    <thead>
        <tr>
            <th style="display:none;">ID</th>
            <th>Num</th>
            <th>姓名</a></th>
            <th>得救時間</th>
        </tr>
    </thead>
    <tbody>
    <?php if (count($data) > 0): ?>
        <?php $index = 1; foreach ($data as $entry): ?>
        <tr>
            <td style="display:none;"><?= htmlspecialchars($entry['id']) ?></td>
            <td><?= $index ?></td>
            <td><?= htmlspecialchars($entry['name']) ?></td>
            <td><?= htmlspecialchars($entry['pray_time']) ?></td>
        </tr>
        <?php $index++; endforeach; ?>
    <?php else: ?>
        <tr>
            <td colspan="8">沒有找到資料。</td>
        </tr>
    <?php endif; ?>
    </tbody>
</table>

<script>
    function confirmDelete(name) {
        return confirm(name + ' 確定要刪除這條記錄嗎？');
    }

    function toggleMessage(cardId) {
        // 根據傳入的 cardId 找到對應的備註區域
        var titleElement = document.getElementById("title-" + cardId);
        var messageElement = document.getElementById("message-" + cardId);
        const cardElement = document.getElementById(`card-${cardId}`);
        var messagebtnElement = document.getElementById("messagebtn-" + cardId);

        // 切換顯示或隱藏
        if (messageElement.style.display === 'none' || messageElement.style.display === '') {
            titleElement.style.display = 'flex';
            messageElement.style.display = 'flex'; // 展開備註
            messageElement.style.textAlign = 'center'; // 展開備註
            cardElement.scrollIntoView({ behavior: 'smooth', block: 'start' });
            messagebtnElement.style.display = 'flex';
        } else {
            titleElement.style.display = 'none';
            messageElement.style.display = 'none';  // 收起備註
            messagebtnElement.style.display = 'none';
        }
    }

    function toggleForm() {
        window.location.href = "index_test.php?district=" + encodeURIComponent('<?= $selectedDistrict ?>');
    }

    // Call the function on page load
    //window.addEventListener('load', adjustCardLayout);
</script>